-----------------------------------------
---- registering event watch
function BuffCheckHelper_OnLoad(Frame)
	Frame:RegisterEvent("CHAT_MSG_RAID")
	Frame:RegisterEvent("CHAT_MSG_RAID_LEADER")
	
end

edbufftable = {} -- empty table for storing info for buff/debuff on raid members
edbuffraid = {} -- empty table for list of raid members
edbufftext = {} -- empty table for list of terms to check matching
edbuffreport = {} -- empty table for storing output reports before chat send
edbuffmissing = {} -- empty table for raid members missing buff/debuff

-----------------------------------------
---- function for collecting buffs/debuffs info on raid members
function EdBuffCollect ()

	table.wipe(edbufftable) -- cleaning tables
	table.wipe(edbuffraid) -- cleaning tables

	for raidindex = 1,GetNumRaidMembers() do
	
		for z = 1,50 do 
			edbuffname = UnitAura("raid"..raidindex, z)
			
			if edbuffname then
            
                edbuffrefresh = 0

                for i = 1,#edbufftable do
					if (edbufftable[i])[1] == edbuffname then
						(edbufftable[i])[2] = (edbufftable[i])[2]..", "..UnitName("raid"..raidindex) -- create new entry for buff in table
                        edbuffrefresh = 1
                        break
                    end
                end
                
                if edbuffrefresh == 1 then 
                else table.insert(edbufftable,{edbuffname, UnitName("raid"..raidindex)}) -- update buff info about raid members
				end
                
			else break
			end
			
		end
    	table.insert(edbuffraid, tostring(UnitName("raid"..raidindex))) -- store raid members name
    				
	end
end

-----------------------------------------
---- function for check match of terms with buff/debuff table and outputing results to raid chat
function EdBuffParse (textmatch)

    EdBuffCollect ()
    
    edbufftext = {strsplit("_", string.lower(textmatch))}
    
	for i = 1,10 do -- check for matching terms in buff/debuff table and add info to report table
		if edbufftext[i] == nil then
			break
        else for z = 1, #edbufftable do
                
                if string.find(string.lower((edbufftable[z])[1]), (edbufftext[i])) then 
                    table.insert(edbuffreport,(format("- BCH - %s : %s", (edbufftable[z])[1], (edbufftable[z])[2])))
                end
            end
		end
	end
        
	for i = 1, #edbuffraid do -- check for raid members not matching any terms and add info to missing table
	
		edbuffaddmissing = 0
		
		for z = 1, #edbuffreport do
			if string.find(edbuffreport[z], edbuffraid[i]) then
				edbuffaddmissing = 0
				break
			else edbuffaddmissing = 1
			end
		end
		
		if (edbuffaddmissing == 1) and (#edbuffmissing ~= 0) then
			edbuffmissing[1] = edbuffmissing[1]..", "..edbuffraid[i]
		elseif (edbuffaddmissing == 1) then
			table.insert(edbuffmissing, edbuffraid[i])
		end
	end
	
	if (#edbuffmissing ~= 0) then -- add line about members missing buffs/debuffs in report table
		table.insert(edbuffreport, (format("- No matching buff/debuff on : %s", edbuffmissing[1])))
	end
	
    if (#edbuffreport ~= 0) then
    	for i = 1,#edbuffreport do -- clean report table of duplicate entries
			for z = 1,#edbuffreport do
                if (edbuffreport[i] == edbuffreport[z]) and (i ~= z) then
                    table.remove(edbuffreport, z)
                end
            end
		end
		
		table.insert(edbuffreport,1,"------------------------------") -- add line at start of report
		table.insert(edbuffreport,"------------------------------")  -- add line at end of report

    	for i = 1,#edbuffreport do -- output report table content to raid chat
			SendChatMessage(edbuffreport[i] ,"RAID" ,nil)
		end
	else SendChatMessage("- BCH - No buffs or debuffs with specified terms in raid." ,"RAID" ,nil) -- in case of no raid members match terms
	end
	
	table.wipe(edbuffreport) -- clean table
    table.wipe(edbufftext) -- clean table
    table.wipe(edbuffmissing) -- clean table

end
	
function BuffCheckHelper_OnEvent(self, event, ...)
-------------------------------
--parsing raid messages for addon call
    if (event == "CHAT_MSG_RAID") or (event == "CHAT_MSG_RAID_LEADER")then

        edraidtext, _, _, _, _ = select(1,...)

    	edparsecommand, textmatch = strsplit(" ", string.lower(edraidtext))
        
        if (edparsecommand == "!bch") then
    	   	EdBuffParse (textmatch)
		end
	end
end

